<?PHP
############################################################################
############################################################################
###	cms4site Browser! (C)2005 cms4site group
############################################################################
############################################################################

############################################################################
function xmmfilegetcontents($QURL,&$HEADER) {
############################################################################
	global $XMMBROWSERURL,$XMMBROWSERNAME,$XMMBROWSERVERSION,$XMMCLEARTAGS;
	global $XMMADVANCEDREQUEST,$XMMBROWSERCOMPAT,$refurl,$XMMADVANCEDREFERER;
	global $XMMCOMPRESSEDSIZE,$XMMALLOWCONTENT;

	$HEADER = array();
	# RETURN IF EMPTY
	if ($QURL=='') return('');

	$QU = parse_url($QURL);
	$REQUEST = "";
	if (!$XMMADVANCEDREQUEST) { # STANDARD URL RETRIEVE
		$REQUEST .= $QU["scheme"].'://'.$QU["host"];
		if ($QU["port"]!="") $REQUEST .= ":".$QU["port"];
		$REQUEST .= "/".$QU["path"];
		if ($QU["query"]!="") $REQUEST .= "?".$QU["query"];
		return(@file_get_contents($REQUEST)); # !!!!!!!!!!!!!! RETURN
		}
	else { # PARSE URL FOR REQUEST FIELDS - ADVANCED RETRIEVE
		$REQUEST .= $QU["path"];
		if ($REQUEST=="") $REQUEST = "/";
		if ($QU["query"]!="") $REQUEST .= "?".$QU["query"];
		if ($QU["port"]!="") $PORT = $QU["port"];
		else $PORT = 80;
		}

	# CONNECT TO SERVER
	$fp = @fsockopen($QU["host"],$PORT,$errno,$errstr,30);
	if (!$fp) {
		return($errstr.'('.$errno.')'."\r\n");
		}
	else {
		# SEND REQUEST TO SERVER
		$out  = "";
		$out .= "GET ".$REQUEST." HTTP/1.1\r\n";
		$out .= "Host: ".$QU["host"]."\r\n";
		if ($refurl!="" && $XMMADVANCEDREFERER) $out .= "Referer: ".$refurl."\r\n"; # !!!
		$out .= "User-Agent: ".$XMMBROWSERNAME."/".$XMMBROWSERVERSION." ".$XMMBROWSERCOMPAT." ".$XMMBROWSERURL."\r\n";
		if (function_exists("gzinflate") && @version_compare(phpversion(),"4.3.0","gt")) $out .= "Accept-Encoding: gzip\r\n";
		else $out .= "Accept-Encoding: identity\r\n";
		$out .= "Connection: Close\r\n";
		$out .= "\r\n";
		fwrite($fp,$out);
		$BUFFER = array();
		$HEADER = array(); # keyed header
		$HEADERVAL = array(); # header lines
		$HEADERFLAG = 2;
		# GET SERVER RESPONSE WITH HEADERS
		while (!feof($fp)) {
			$BF = fgets($fp);
			if ($HEADERFLAG==0) $BUFFER[] = $BF; # NORMAL DATA LINE
			if ($HEADERFLAG>0 && trim($BF)=="") $HEADERFLAG = 0; # END OF HEADER - SKIP THIS LINE
			if (trim($BF)!="" && $HEADERFLAG>0) { # RESPONSE HEADER
				if ($HEADERFLAG==2) { # RESPONSE FIRST LINE
					$HEADER["HTTP"] = $BF;
					$HEADERVAL[] = $BF;
					}
				else { # PARSE RESPONSE HEADER
					$HA = explode(": ",$BF);
					$HK = strtolower(array_shift($HA));
					$HEADER[$HK] = trim(implode(": ",$HA));
					$HEADERVAL[] = $BF;
					}
				}
			if ($HEADERFLAG==2) $HEADERFLAG = 1; # PASSED FIRST LINE - HEADER FOLLOWS
			}
		fclose($fp);
		# JOIN BUFFERS TO STRING
		$HEADERVAL = implode("",$HEADERVAL);
		$BUFFER = implode("",$BUFFER);
		# UNCHUNK BUFFER len##chunk##len##chunk##len##chunk where len is hex value
		if ($HEADER["transfer-encoding"]=="chunked") {
			$CURR = 0;
			$RESULT = "";
			for ($i=0;$i<strlen($BUFFER);$i++) {
				if (substr($BUFFER,$i,2)=="\r\n") {
					$CHUNKLEN = hexdec(trim(substr($BUFFER,$CURR,$i-$CURR)));
					$RESULT = $RESULT.substr($BUFFER,$i+2,$CHUNKLEN);
					$i = $i + 4 + $CHUNKLEN;
					$CURR = $i;
					}
				}
			$BUFFER = $RESULT;
			}
		# MAKE RESULT
		$XMMCOMPRESSEDSIZE = strlen($BUFFER);
		if (substr($HEADER["content-encoding"],0,4)=="gzip" && function_exists("gzinflate")) $BUFFER = gzinflate(substr($BUFFER,10));
		# CHECK CONTENT TYPE
		if ($HEADER["location"]!='') {
			$BUFFER = '<LOCATION7788 HREN4000="'.$HEADER["location"].'">'."\r\n".$BUFFER;
			}
		$CTYPE = explode(";",$HEADER["content-type"]);
		if (!in_array(trim($CTYPE[0]),$XMMALLOWCONTENT)) $BUFFER = $HEADERVAL."\xa0\r\n";
		elseif (!$XMMCLEARTAGS) $BUFFER = $HEADERVAL."\xa0\r\n".$BUFFER;
		# RETURN RESULT
		return($BUFFER);
		}
	}

############################################################################
function xmmgetfile($QURL,&$fileflag,&$contentencoding,&$HEADER) {
############################################################################
	global $XMMALLOWIMAGE,$XMMALLOWFILE,$XMMFORBIDDEN,$XMMALLOWCONTENT,$XMMADVANCEDREQUEST;
	$fileflag = 0;
	$contentencoding = '';
	$EX = explode("?",$QURL);
	$EX = explode(".",$EX[0]);
	$EX = array_pop($EX);
	if (in_array($EX,$XMMALLOWIMAGE)) {
		$QQ = '<FONT COLOR="#FF0000">'.htmlentities(XMMLocale("mybrimage"),ENT_QUOTES,'cp1251').':</FONT> <A HREF="'.$QURL.'">'.htmlspecialchars($QURL,ENT_QUOTES).'</A>';
		$fileflag = 1;
		}
	elseif (in_array($EX,$XMMALLOWFILE)) {
		$QQ = '<FONT COLOR="#FF0000">'.htmlentities(XMMLocale("mybrfile"),ENT_QUOTES,'cp1251').':</FONT> <A TARGET="_blank" HREF="'.$QURL.'">'.htmlspecialchars($QURL,ENT_QUOTES).'</A>';
		$fileflag = 2;
		}
	elseif (!in_array($EX,$XMMFORBIDDEN)) {
		########################################
		$QQ = xmmfilegetcontents($QURL,$HEADER);
		########################################
		$contentencoding = htmlspecialchars($HEADER["content-type"],ENT_QUOTES);
		$CTYPE = explode(";",$HEADER["content-type"]);
		if (!in_array(trim($CTYPE[0]),$XMMALLOWCONTENT) && $XMMADVANCEDREQUEST && $QURL!='') {
			$QQ = $QQ.'<FONT COLOR="#FF0000">'.htmlentities(XMMLocale("mybrerr3"),ENT_QUOTES,'cp1251').'</FONT>';
			$fileflag = 4;
			}
		elseif (trim($CTYPE[1])=='') { # if no header charset, try to get charset from meta tags
			$contentencoding = xmmtrymetacharset($QQ,$contentencoding);
			}
		}
	else {
		$QQ = '<FONT COLOR="#FF0000">'.htmlentities(XMMLocale("mybrforbidden"),ENT_QUOTES,'cp1251').':</FONT> '.htmlspecialchars($QURL,ENT_QUOTES);
		$fileflag = 3;
		}
	return($QQ);
	}

############################################################################
function xmmtrymetacharset($QQ,$contentencoding) {
############################################################################
	# <meta http-equiv="content-type" content="text/html; charset=windows-1251">
	$meta = array();
	preg_match_all("'<meta[^>]*?>'si",$QQ,$meta); # find all meta's
	$meta = $meta[0];
	if (sizeof($meta)>0) {
		foreach($meta as $metatag) {
			$metatag = str_replace("'",'"',$metatag); # unify quoting
			$there1 = preg_match("'http-equiv=[\"]{0,1}content-type'si",$metatag);
			if ($there1==1) {
				$there2 = preg_match("'content=\"[^\"]{0,}\"'si",$metatag,$match);
				if ($there2==1) { # we're interested in charset, so it will be quoted always, content=text/html will be skipped
					$contentencoding = htmlspecialchars(trim(substr($match[0],9,-1)));
					if (strlen($contentencoding)<111) return($contentencoding);
					}
				}
			}
		}
	return($contentencoding.'; '.XMMLocale("charset"));
	}

############################################################################
function xmmprinthead($QURL,$contentencoding='') {
############################################################################
	global $XMMBROWSERNAME, $THISLANGUAGE;
	print('<HTML>');
	print('<HEAD>');
	$QA = parse_url($QURL);
	$QU = $QA["host"].$QA["path"];
	if ($QA["query"]!='') $QU .= '?'.$QA["query"];
	if (strlen($QU)>80) $QU = substr($QU,0,80).'...';
	if ($QU!='') $QU .= ' - ';
	$contentencoding = trim($contentencoding);
	$cea = explode(' ',$contentencoding);
	if (trim($cea[1])=='') $cea[1] = 'charset='.XMMLocale("charset");
	$contentencoding = 'text/html; '.trim($cea[1]);
	print('<META HTTP-EQUIV="Content-Type" CONTENT="'.$contentencoding.'">');
	header('Content-Type: '.$contentencoding);
	print('<META NAME="Content-Language" content="'.substr($THISLANGUAGE,0,2).'">');
	print('<TITLE>'.$QU.$XMMBROWSERNAME.'</TITLE>');
	print('<STYLE>');
	print('BODY,TD,A,TT,PRE,INPUT{font-size:12px;font-family:Fixedsys}');
	print('.NU{text-decoration:none}');
	print('</STYLE>');
	print('</HEAD>');
	}

############################################################################
function xmmmakeactivelinks($QQ) {
############################################################################
	global $QSERVER,$q1,$q2,$q3,$q4,$q5,$q6,$q7,$QURL,$XMMADVANCEDREFERER;
	$out = '';
	$BASEURL = '';
	for ($i=0;$i<strlen($QQ);$i++) {
		$hrefstart = 0;
		$isanchor = false;
		$isbase = false;
		$isframe = false;
		$isiframe = false;
		$islocation = false;
		$hrefparm = '';
		# A HREF
		$tag = strtolower(substr($QQ,$i,6));
		if ($tag=="&lt;a\x20" || $tag=="&lt;a\n" || $tag=="&lt;a\t") {
			$isanchor = true;
			$hrefstart = 5;
			$hrefparm = 'href=';
			}
		else {
			# BASE HREF
			$tag = strtolower(substr($QQ,$i,9));
			if ($tag=="&lt;base\x20" || $tag=="&lt;base\n" || $tag=="&lt;base\t") {
				$isbase = true;
				$hrefstart = 5;
				$hrefparm = 'href=';
				}
			else {
				# FRAME SRC
				$tag = strtolower(substr($QQ,$i,10));
				if ($tag=="&lt;frame\x20" || $tag=="&lt;frame\n" || $tag=="&lt;frame\t") {
					$isframe = true;
					$hrefstart = 4;
					$hrefparm = 'src=';
					}
				else {
					# IFRAME SRC
					$tag = strtolower(substr($QQ,$i,11));
					if ($tag=="&lt;iframe\x20" || $tag=="&lt;iframe\n" || $tag=="&lt;iframe\t") {
						$isiframe = true;
						$hrefstart = 4;
						$hrefparm = 'src=';
						}
					else {
						# LOCATION HREN
						$tag = strtolower(substr($QQ,$i,17));
						if ($tag=="&lt;location7788\x20" || $tag=="&lt;location7788\n" || $tag=="&lt;location7788\t") {
							$islocation = true;
							$hrefstart = 9;
							$hrefparm = 'hren4000=';
							}
						}
					}
				}
			}
		# LINK SUSPECTED
		if ($isanchor || $isframe || $isiframe || $isbase || $islocation) {
			# START OF LINK
			$islink = false;
			for ($j=$i;$j<strlen($QQ);$j++) {
				$par = strtolower(substr($QQ,$j,$hrefstart));
				if ($par==$hrefparm) {
					for ($k=$j+$hrefstart;$k<strlen($QQ);$k++) {
						$next = substr($QQ,$k,1);
						$next2 = substr($QQ,$k,4);
						if ($next==" " || $next=="\t" || $next2=="&gt;") {
							$link = substr($QQ,$j+$hrefstart,$k-$j-$hrefstart);
							$from = $i;
							$to = max($i,$k-1);
							$i = $to;
							$islink = true;
							break;
							}
						}
					}
				if (substr($QQ,$j,4)=="&gt;") {
					$i = $j+3;
					break;
					}
				}
			# PROCESS LINK
			if ($islink) {
				$link = str_replace(array('&quot;','&#039;','&lt;','&gt;'),'',$link); # IBO NEFIG!
				if (function_exists("html_entity_decode")) $link = html_entity_decode($link);
				$link = str_replace("\n",'',$link);
				$scriptmatch = "/^(jscript:|javascript:|vbscript:|res:|telnet:|view-source:|file:)/i";
				while (preg_match($scriptmatch,$link)) $link = preg_replace($scriptmatch,"",$link);
				$link = strip_tags($link);
				if (strtolower(substr($link,0,7))!="mailto:") {
					if ($isbase && $BASEURL=='') $BASEURL = $link; # FIRST BASE HREF
					$link = XMMBuildFullLink($QURL,$link,$BASEURL);
					$linkencoded = myurlencode($link);
					if ($XMMADVANCEDREFERER) $refererencoded = myurlencode($QURL);
					else $refererencoded = '';
					$out = $out.'<A TARGET="_top" HREF="xmmbrowser.php?q1='.$q1.'&q2='.$q2.'&q3='.$q3.'&q4='.$q4.'&q5='.$q5.'&q6='.$q6.'&q7='.$q7.'&url='.$linkencoded.'&refurl='.$refererencoded.'" TITLE="'.htmlspecialchars($link,ENT_QUOTES).'"><IMG SRC="ylink.gif" BORDER="0" ALIGN="baseline">';
					if ($isbase) $out = $out.'<FONT COLOR="#CC6600" CLASS="NU">BASEURL</FONT></A>';
					elseif ($isframe) $out = $out.'<FONT COLOR="#CC6600" CLASS="NU">FRAME</FONT></A>';
					elseif ($isiframe) $out = $out.'<FONT COLOR="#CC6600" CLASS="NU">IFRAME</FONT></A>';
					elseif ($islocation) $out = $out.'<FONT COLOR="#CC6600" CLASS="NU">LOCATION</FONT></A>';
					}
				else { # mailto
					$out = $out.'<A onClick="return(confirm(\''.htmlentities(XMMLocale("mybraskactivate"),ENT_QUOTES,'cp1251').'\'))" HREF="'.$link.'" TITLE="'.htmlspecialchars($link).'"><IMG SRC="ylink.gif" BORDER="0" ALIGN="baseline">';
					}
				}
			}
		# NEXT CHAR
		else $out = $out.substr($QQ,$i,1);
		}
	# FINALLY REPLACE END A TAGS
	$out = str_replace(array("&lt;/A&gt;","&lt;/a&gt;"),"</A>",$out);
	$out = preg_replace("'&lt;/iframe&gt;'i","",$out);
	return($out);
	}

###############################################################################
function xmmparseurl($QLINK) {
###############################################################################
	# struggle with /go?url=http://www.www.www&ref=http://www.ggg.sss
	# or even ?http://ddd.eee.sss /http://sss.aaa.vvv... et other botva
	$HASH = md5($QLINK);
	while (strpos($QLINK,$HASH)!==FALSE) $HASH = md5($HASH.$HASH); # unique replacement string
	while (strrpos($QLINK,'://')>4) { # find all inner schemes
		$Q2 = strrpos($QLINK,'://');
		$QLINK = substr_replace($QLINK,$HASH,$Q2,3);
		}
	$QL = parse_url($QLINK);
	foreach ($QL as $QK => $QE) $QL[$QK] = str_replace($HASH,'://',$QE); # restore them back
	return($QL);
	}

###############################################################################
function XMMBuildFullLink($QURL,$QLINK,$QBASE) { # APPLY RELATIVE/ABSOLUTE LINK TO CURRENT URL
###############################################################################
	if ($QBASE!='') $QURL = $QBASE;
	$QU = parse_url($QURL);
	$Q1 = strrpos($QLINK,'http://');
	$Q2 = strrpos($QLINK,'://');
	if ($Q1>0 || $Q2>4) $QL = xmmparseurl($QLINK);
	else $QL = parse_url($QLINK);
	# scheme://user:pass@host:port/path?query#fragment
	# print_r($QU);
	# print('<BR>');
	# print_r($QL);
	# print('<BR>');
	$RLINK = '';
	if ($QL["scheme"]!='' && $QL["host"]!='') { # FULL LINK WILL TOTALLY REPLACE CURRENT URL
		# REALLY THIS IS NOT NECESSARY AS IT IS THE REVERESE OF parse_url
		# EXCEPT mailto PROCESSING
		if ($QL["scheme"]!='mailto') $RLINK .= $QL["scheme"].'://';
		else $RLINK .= $QL["scheme"].':';
		if ($QL["user"]!='') $RLINK .= $QL["user"];
		if ($QL["pass"]!='') $RLINK .= ':'.$QL["pass"];
		if ($QL["user"]!='' || $QL["pass"]!='') $RLINK .= '@';
		$RLINK .= $QL["host"];
		if ($QL["port"]!='') $RLINK .= ':'.$QL["port"];
		if ($QL["path"]!='') $RLINK .= $QL["path"];
		if ($QL["query"]!='') $RLINK .= '?'.$QL["query"];
		if ($QL["fragment"]!='') $RLINK .= '#'.$QL["fragment"];
		if ($RLINK!=$QLINK) $RLINK = '';
		return($RLINK);
		}
	elseif (substr($QLINK,0,1)=='#') { # LABEL ONLY
		$RLINK .= $QU["scheme"].'://';
		if ($QU["user"]!='') $RLINK .= $QU["user"];
		if ($QU["pass"]!='') $RLINK .= ':'.$QU["pass"];
		if ($QU["user"]!='' || $QU["pass"]!='') $RLINK .= '@';
		$RLINK .= $QU["host"];
		if ($QU["port"]!='') $RLINK .= ':'.$QU["port"];
		$RLINK .= $QU["path"];
		if ($QL["query"]!='') $RLINK .= '?'.$QL["query"];
		$RLINK .= $QLINK;
		}
	elseif (substr($QLINK,0,1)=='?') { # QUERY AND MAYBE LABEL
		$RLINK .= $QU["scheme"].'://';
		if ($QU["user"]!='') $RLINK .= $QU["user"];
		if ($QU["pass"]!='') $RLINK .= ':'.$QU["pass"];
		if ($QU["user"]!='' || $QU["pass"]!='') $RLINK .= '@';
		$RLINK .= $QU["host"];
		if ($QU["port"]!='') $RLINK .= ':'.$QU["port"];
		$RLINK .= $QU["path"];
		if ($QL["query"]!='') $RLINK .= '?'.$QL["query"];
		if ($QL["fragment"]!='') $RLINK .= '#'.$QL["fragment"];
		}
	else { # RELATIVE LINK WILL USE CURRENT HOST+ AND REPLACE PATH+
		$RLINK .= $QU["scheme"].'://';
		if ($QU["user"]!='') $RLINK .= $QU["user"];
		if ($QU["pass"]!='') $RLINK .= ':'.$QU["pass"];
		if ($QU["user"]!='' || $QU["pass"]!='') $RLINK .= '@';
		$RLINK .= $QU["host"];
		if ($QU["port"]!='') $RLINK .= ':'.$QU["port"];
		if (substr($QL["path"],0,1)=="/") { # ABSOLUTE PATH STARTING WITH /
			$RLINK .= $QL["path"];
			}
		else { # RELATIVE TO THE CURRENT PATH
			$NP = explode('/',$QU["path"]);
			array_pop($NP);
			$NP = implode('/',$NP).'/'.$QL["path"];
			$NP = explode('/',$NP);
			# CHECK NEW PATH FOR BACKS ../ AND CURRENTS ./
			$NPN = $NP;
			if (sizeof($NP)>2) {
				$NPN = array();
				for ($i=0;$i<sizeof($NP);$i++) {
					if ($NP[$i]=='..') array_pop($NPN);
					elseif ($NP[$i]!='.') $NPN[] = $NP[$i];
					}
				}
			$NP = implode('/',$NPN);
			if (substr($NP,0,1)!='/') $NP = '/'.$NP;
			$RLINK .= $NP;
			}
		# ADD OTHER FEATURES
		if ($QL["query"]!='') $RLINK .= '?'.$QL["query"];
		if ($QL["fragment"]!='') $RLINK .= '#'.$QL["fragment"];
		}
	return($RLINK);
	}

###############################################################################
function XMMGetVariables() {
###############################################################################
	while (list($variable,$value) = each($_REQUEST)) {
		global $$variable;
		if(isset($$variable)) continue;
		$$variable = $value;
		}
	}

############################################################################
function xmmgettimeinterval($timeintervalstart=0) {
############################################################################
	list($unixepochsec,$mksecinsec) = explode(" ",microtime());
	return ((float)$unixepochsec+(float)$mksecinsec-(float)$timeintervalstart);
	}

############################################################################
function xmmprintoptions() {
############################################################################
	global $XMMBROWSERNAME,$XMMBROWSERVERSION;
	global $XMMWRAPMODE,$XMMCLEARTAGS,$XMMCLEARNBSP,$XMMACTIVELINKS,$XMMKOIENCODING,$XMMSHOWLINEBREAK,$XMMCLEAREMPTY,$XMMBREAKTAGS;
	print('<TABLE CELLPADDING="0" CELLSPACING="0" BORDER="0" WIDTH="100%"><TR>');
	print('<TD TITLE="'.XMMLocale("reload").'" WIDTH="99%" ALIGN="left" onClick="document.furl.submit();return(false)" STYLE="cursor:hand"><NOBR><FONT COLOR="#FFFF00"><IMG ALIGN="absmiddle" SRC="ylogo.gif" BORDER="0">'.$XMMBROWSERNAME.' '.$XMMBROWSERVERSION.'</TD><TD>&nbsp;</TD>');
	# WRAP
	$TXT = XMMLocale("mybrwrap");
	if ($XMMWRAPMODE) $CHK = " CHECKED";
	else $CHK = "";
	print('<TD><INPUT STYLE="cursor:hand" TITLE="'.$TXT.'" onFocus="this.blur()" onClick="document.furl.submit()" TYPE="CHECKBOX" NAME="q1"'.$CHK.'></TD>');
	print('<TD><FONT COLOR="#FFFFFF" TITLE="'.$TXT.'">wrap</TD><TD>&nbsp;</TD>');
	# TAGS
	$TXT = XMMLocale("mybrtags");
	if (!$XMMCLEARTAGS) $CHK = " CHECKED";
	else $CHK = "";
	print('<TD><INPUT STYLE="cursor:hand" TITLE="'.$TXT.'" onFocus="this.blur()" onClick="document.furl.q4.value=\'\';document.furl.submit()" TYPE="CHECKBOX" NAME="q2"'.$CHK.'></TD>');
	print('<TD><FONT COLOR="#FFFFFF" TITLE="'.$TXT.'">tags</TD><TD>&nbsp;</TD>');
	# NBSP
	$TXT = XMMLocale("mybrnbsp");
	if (!$XMMCLEARNBSP) $CHK = " CHECKED";
	else $CHK = "";
	print('<TD><INPUT STYLE="cursor:hand" TITLE="'.$TXT.'" onFocus="this.blur()" onClick="document.furl.submit()" TYPE="CHECKBOX" NAME="q3"'.$CHK.'></TD>');
	print('<TD><FONT COLOR="#FFFFFF" TITLE="'.$TXT.'">nbsp</TD><TD>&nbsp;</TD>');
	# LINKS
	$TXT = XMMLocale("mybrlink");
	if ($XMMACTIVELINKS) $CHK = " CHECKED";
	else $CHK = "";
	print('<TD><INPUT STYLE="cursor:hand" TITLE="'.$TXT.'" onFocus="this.blur()" onClick="document.furl.q2.value=\'\';document.furl.submit()" TYPE="CHECKBOX" NAME="q4"'.$CHK.'></TD>');
	print('<TD><FONT COLOR="#FFFFFF" TITLE="'.$TXT.'">link</TD><TD>&nbsp;</TD>');
	# KOI8
	$TXT = XMMLocale("mybrkoi8");
	if ($XMMKOIENCODING) $CHK = " CHECKED";
	else $CHK = "";
	print('<TD><INPUT STYLE="cursor:hand" TITLE="'.$TXT.'" onFocus="this.blur()" onClick="document.furl.submit()" TYPE="CHECKBOX" NAME="q7"'.$CHK.'></TD>');
	print('<TD><FONT COLOR="#FFFFFF" TITLE="'.$TXT.'">koi8</TD><TD>&nbsp;</TD>');
	# BREAKS
	$TXT = XMMLocale("mybrends");
	if ($XMMSHOWLINEBREAK) $CHK = " CHECKED";
	else $CHK = "";
	print('<TD><INPUT STYLE="cursor:hand" TITLE="'.$TXT.'" onFocus="this.blur()" onClick="document.furl.submit()" TYPE="CHECKBOX" NAME="q5"'.$CHK.'></TD>');
	print('<TD><FONT COLOR="#FFFFFF" TITLE="'.$TXT.'">ends</TD><TD>&nbsp;</TD>');
	# EMPTY
	$TXT = XMMLocale("mybrempty");
	if (!$XMMCLEAREMPTY) $CHK = " CHECKED";
	else $CHK = "";
	print('<TD><INPUT STYLE="cursor:hand" TITLE="'.$TXT.'" onFocus="this.blur()" onClick="document.furl.submit()" TYPE="CHECKBOX" NAME="q6"'.$CHK.'></TD>');
	print('<TD><FONT COLOR="#FFFFFF" TITLE="'.$TXT.'">empty</TD><TD>&nbsp;</TD>');
	print('</TR></TABLE>');
	}

############################################################################
function xmmprocesspage($QQ) {
############################################################################
	global $XMMWRAPMODE,$XMMCLEARTAGS,$XMMCLEARNBSP,$XMMACTIVELINKS,$XMMKOIENCODING,$XMMSHOWLINEBREAK,$XMMCLEAREMPTY,$XMMBREAKTAGS;
	# WRAP/NOWRAP
	if ($XMMWRAPMODE) print('<TT>');
	else print('<PRE>');
	# NORMALIZE LINE BREAKS
	$QQ = str_replace(array("\n\r","\r\n","\r"),"\n",$QQ);
	# BREAK ON CERTAIN TAGS
	if ($XMMBREAKTAGS) $QQ = preg_replace("/(<TABLE|<TR|<TD|<BR|<P|<UL|<OL|<LI|<DIR|<\/TABLE)/i","\n\\1",$QQ);
	# CLEAR TAGS
	if ($XMMCLEARTAGS) {
		# striptags leaves inner lines
		$SCRIPTX = array("'<script[^>]*?>.*?</script>'si","'<style[^>]*?>.*?</style>'si");
		$SCRIPTY = array("","");
		$QQ = preg_replace($SCRIPTX,$SCRIPTY,$QQ);
		if ($XMMACTIVELINKS) $QQ = strip_tags($QQ,"<A><BASE><FRAME><IFRAME><LOCATION7788>");
		else $QQ = strip_tags($QQ);
		}
	# CLEAR SPACES, TABS AND NBSP'S
	if ($XMMCLEARNBSP) {
		$QQ = str_replace(array("&nbsp;","\t")," ",$QQ);
		$QQ = preg_replace("/[\x20]{1,}/"," ",$QQ);
		}
	# CLEAR EMPTY LINES
	$QQ = preg_replace("/[\x20|\t]{1,}\n/","\n",$QQ);
	if ($XMMCLEAREMPTY) $QQ = preg_replace("/[\n]{2,}/","\n",$QQ);
	$QQ = preg_replace("/[\n]{3,}/","\n\n",$QQ);
	$QQ = trim($QQ);
	# MAKE PRINTABLE
	$QQ = htmlspecialchars($QQ,ENT_QUOTES);
	# MAKE LINKS
	if ($XMMACTIVELINKS) $QQ = xmmmakeactivelinks($QQ);
	# WRONG ENCODING
	if ($XMMKOIENCODING) $QQ = convert_cyr_string($QQ,"k","w");
	if ($XMMCLEARNBSP) $QQ = str_replace(array("&amp;mdash;","&amp;ndash;","&amp;deg;","&amp;euro;","&amp;#8482;","&amp;#151;","&amp;#150;","&amp;laquo;","&amp;raquo;","&amp;quot;","&amp;copy;","&amp;reg;","&amp;amp;","&amp;middot;","&amp;sect;"),array("-","-","&deg;","&euro;","&#8482;","&#151;","&#150;","&laquo;","&raquo;","&quot;","&copy;","&reg;","&amp;","-","&sect;"),$QQ);
	return($QQ);
	}

############################################################################
function xmmoutputpage($QQ) {
############################################################################
	global $XMMWRAPMODE,$XMMCLEARTAGS,$XMMCLEARNBSP,$XMMACTIVELINKS,$XMMKOIENCODING,$XMMSHOWLINEBREAK,$XMMCLEAREMPTY,$XMMBREAKTAGS;
	# MAKE LINES ARRAY
	$QQ = explode("\n",$QQ);
	# OUTPUT LINES
	$CTR = 0;
	if (sizeof($QQ)>0 && $QQ!="") {
		foreach($QQ as $Q) {
			$Q = trim($Q); # STRIP SIDE SPACES
			if (!($Q=="" && $XMMCLEAREMPTY)) { # SKIP EMPTY
				$CTR++;
				print($Q);
				if ($XMMSHOWLINEBREAK) print('<FONT COLOR="#CCCCCC">&#182;</FONT>');
				print('<BR>');
				}
			}
		}
	return($CTR);
	}

############################################################################
function myurlencode($str) {
############################################################################
	return(rawurlencode($str));
	}

############################################################################
function myurldecode($str) {
############################################################################
	return(rawurldecode($str));
	}

############################################################################
function xmmrealsize($str) {
############################################################################
	if (strlen($str)==0) return(0);
	$accept = explode(',',getenv("HTTP_ACCEPT_ENCODING"));
	for ($i=0;$i<sizeof($accept);$i++) $accept[$i] = trim($accept[$i]);
	if (function_exists("gzencode") && in_array("gzip",$accept)) return(strlen(gzencode($str)));
	elseif (function_exists("gzdeflate") && in_array("deflate",$accept)) return(strlen(gzdeflate($str)));
	else return(strlen($str));
	}

#########################################################################
function XE($q) {
#########################################################################
	if ($q=='') return($q);
	$p = '';
	for ($i=0;$i<strlen($q);$i++) {
		$p .= str_pad(dechex(ord(substr($q,$i,1))),'0',2,STR_PAD_LEFT);
		}
	$p = strrev($p);
	return($p);
	}

#########################################################################
function XD($p) {
#########################################################################
	if ($p=='') return($p);
	$p = strrev($p);
	$q = '';
	for ($i=0;$i<strlen($p);$i++) {
		$q .= chr(hexdec(substr($p,$i,2)));
		$i++;
		}
	return($q);
	}

	?>